//==============================================================================
#include "main.h"

#include <avr/interrupt.h>   
#include <avr/sleep.h>

extern unsigned char chas, mins, sec;
extern unsigned int prawka;  // для расчета поправки времени

// режим работы, 1 - питание от сети, 0 - работа от аккумулятора
extern unsigned char regim;
extern unsigned char vcct;
extern unsigned char kn;

//==============================================================================
// таймер работает в асинхронном режиме с кварцем 32768 Гц
//------------------------------------------------------------------------------
void initT2(void)
{ ASSR |= (1<<AS2);           // Включаем асинхронный режим T2
//  TCNT2 = 0;
  TCCR2A = 0x00;
  TCCR2B = (5<<CS20);
  OCR2A = 0x00;
  OCR2B = 0x00;
  TIMSK2 |= (1 << TOIE2);
}
//===============================================================================
void minit(void)
{ 
//  CLKPR=0x80; CLKPR=0x00; // Crystal Oscillator division factor: 1
  UCSR0B = 0x00;  // USART initialization - disabled
// Analog Comparator initialization - Off
// Input Capture by Timer/Counter 1: Off
  ACSR = 0x80;
  ADCSRB = 0x00;
  DIDR1 = 0x00;

  SPCR = 0x00;  // SPI initialization - disabled
  TWCR = 0x00;  // TWI initialization - disabled
// External Interrupt(s) initialization - INT0=Off INT1=Off
  EICRA = 0x00;
  EIMSK = 0x00;
  PCICR = 0x00;
  TIMSK1 = 0x00;

  initT2();

  set_sleep_mode(SLEEP_MODE_PWR_SAVE);  // установка параметров малопотребляющего режима
  sleep_enable();

  sei();
}
//===============================================================================
// "спящий" режим
void mslipping(void)
{ 
// обнуление выходов портов для дисплея
  PORTD = 0b00000000;
  PORTC &= 0b11110000;
  _delay_ms(1);
  while(ASSR & (1<<TCN2UB)) {;}
  _delay_us(100);
  asm("sleep");
  _delay_us(100);
}
//===============================================================================
ISR(TIMER2_OVF_vect)
{ sec++;
  { if (sec > 59)
    { sec = 0;
      mins++; 
      if (mins > 59)
      { mins = 0;
        chas++;
        if (chas > 23) chas = 0;
      }
    }
  }
  vcct = getADC8(14);
}
//===============================================================================

