//==============================================================================
#include "main.h"

extern "C" unsigned char getADC8(unsigned char nomeradc);
volatile unsigned char vcct = 0;

// напряжение при питании от сети 
unsigned char VCC __attribute__ ((section(".noinit")));

// напряжение при питании от аккумулятора
unsigned char VCCB __attribute__ ((section(".noinit")));

extern "C" 
{ void minit(void);
  void knopki(void);
  void mslipping(void);
  void initTFT(void);
  void ekran0(void);
  void showtime(void);
  void grafik(void);
  void show_hum(unsigned char temper,unsigned char hum);
}

extern "C" 
{ void i2c_init (void);
  void BMP180_Calibration (void); // получить данные для калибровки
  void BMP180_calculation (int32_t* temperature, int32_t* pressure);
}
int32_t pressure = 0;
int32_t temperature = 0;

//-----------------------------------------------------------------
unsigned char chas __attribute__ ((section(".noinit")));
unsigned char mins __attribute__ ((section(".noinit")));
unsigned char sec __attribute__ ((section(".noinit")));

// режим работы, 1 - питание от сети, 0 - работа от аккумулятора
volatile unsigned char 
  oldregim = 0, // предыдущее значение
  regim   = 0;  // текущее значение

unsigned int dawl[MAXDAT] __attribute__ ((section(".noinit")));  // массив значений давления
volatile unsigned int dawlen  = 0;   // последнее измеренное значение давления
volatile unsigned char temper = 0;  // последнее измеренное значение давления

//==============================================================================
void setup()
{
  minit();

}
//===============================================================================
// опрос датчика
void datchik(void)
{
  if (((mins==2) && (sec==10)) || ((mins==32) && (sec==10)))
  { 
    i2c_init();
    BMP180_Calibration();
    BMP180_calculation (&temperature, &pressure);
    temper = temperature/10; // от датчика давления
    dawlen = (pressure*3)/80;
//----- сдвигаем данные в массиве
    unsigned char i = 0;
    for (i = 1; i < MAXDAT; i++)
    {   dawl[i-1] = dawl[i];
    }
    dawl[MAXDATt] = dawlen;

    if (regim==1) grafik();
  }
}
//===============================================================================
void loop(void)
{
  datchik();
//#define POROG 80  // для контроллера ATMEGA8
#define POROG 60  // для контроллера ATMEGA328

  if (vcct < POROG) // есть питание от сети
  {
    regim = 1;
    VCC = vcct;
    if (oldregim == 0)// если питание от сети только что включилось
    { 
      initTFT();
      ekran0();
      grafik();
    } 
    knopki();
    showtime();
  }
  else        // питание от аккумулятора
  {
    regim = 0;
    VCCB = vcct;
    mslipping();          // "спящий" режим
  }  
  oldregim = regim;
}
//===============================================================================

