//==============================================================================
// функции  для работы с экраном
//==============================================================================
#include "main.h"

#define BLACK     0x0000
#define WHITE     0xFFFF
#define RED       0b1111100000000000
#define GREEN     0b0000011111100000
#define POLUGREEN 0b0000001111100000
#define BLUE      0b0000000000011111

#define GREY      0b0111101111101111
#define GREY1     0b0000011111111111
#define YELLOW    0b1111111111100000
#define FON       0b0000000000000011  // фон тёмно-тёмно синий

extern unsigned char chas,mins,sec;
extern unsigned int dawlen;
extern unsigned int dawl[MAXDAT];

extern unsigned char VCC,VCCB;

void put_char(
  unsigned int x,     // по вертикали
  unsigned int y,     // по горизонтали
  unsigned char size,
  unsigned int color, unsigned int backcolor, 
  unsigned char ch);  // символ

void SVLine( // рисуем вертикальную линию
  unsigned int x1,
  unsigned int y1, unsigned int y2,
  unsigned int color);

void SHLine( // рисуем горизонтальную линию
  unsigned int x1,unsigned int x2, 
  unsigned int y1,
  unsigned int color);

#define DrawPixel(p1,p2,p3) TFT9341_DrawPixel(p1,p2,p3)
//==============================================================================
void ekran0(void)
{ unsigned int x = 0;
//---------------------------------------- чистим верхнюю и нижнюю области
  for (x = 0; x < 240; x++)
  { 
    SVLine(x,311,319,FON);   // левая вертикаль
    SVLine(x,0,59,FON);   // левая вертикаль
  }
//---------------------------------------- чистим место под шкалой справа
  for (x = 221; x < 240; x++) 
    SVLine(x,61,309,FON);
//------------------------------------------------------------------------------
// строка с версией
  unsigned char sym[8]={11,12,2,2,0,4,1,0};
  unsigned char i = 0, y0 = 0;
  for (i = 0; i < 8; i++)
  { put_char(311,y0,1,GREEN,FON,sym[i]);
    y0 += 6;  
  }

  SHLine(0,239,310,WHITE);  // верхняя горизонталь
  SHLine(0,239,60,WHITE);  // нижняя горизонталь
//------------------------------------ шкала справа
  //unsigned char 
  i = 6;
  for (x = 260; x > 100; x-=50)
  { SHLine(221,239,x,WHITE);  // нижняя горизонталь
    put_char(x+2,223,1,WHITE,FON,7);
    put_char(x+2,229,1,WHITE,FON,i);
    put_char(x+2,235,1,WHITE,FON,0);
    i--;
  }
  SVLine(0,60,310,WHITE);   // левая вертикаль
  SVLine(214,60,310,WHITE); // правая вертикаль

// строка с температурой и влажностью
  unsigned char sym2[13] = {13,14,9,9,15,16,17,18,19,14,9,9,20};
  i = 0;
  y0 = 40;
  for (i = 0; i < 13; i++)
  { put_char(36,y0,2,0b1111111111100000,FON,sym2[i]);
    y0 += 11;
    if (i==6) y0 += 20;
  }
}
//==============================================================================
void grafik(void)
{ unsigned char i = 0;
  unsigned int gde = 270; // где писать давление
  unsigned int tmp = 0;
  
  for (i = 0; i < MAXDAT; i++)
  { 
    SVLine(i+2,61,309,FON);    // стиралка
    
    if ((i==20)||(i==68)||(i==116)||(i==164)) 
      SVLine(i+2,61,309,GREY);   // сутошная линия

    DrawPixel(110,i+2,GREY);  // серые горизонтали
    DrawPixel(160,i+2,GREY);  
    DrawPixel(210,i+2,GREY);  
    DrawPixel(260,i+2,GREY);  
//------------------------- отработка зашкала менее 720 и более 770 миллиметров
    tmp = dawl[i];
    // нижний 3600, верхний 3850
    if (tmp < 3600) tmp = 3600; 
    if (tmp > 3849) tmp = 3849;

    if (i > (MAXDAT-48))
    { if (tmp > 3800) gde = 120;
    } 
    tmp -= 3600;  // уровень 720 мм рт.ст. 
    DrawPixel(61 + tmp,i+2,WHITE);
  }
  unsigned int tmp1;
//-------------------------------------- красная колонка
  if (dawlen > 3849)  tmp1 = 3849;	// ограничение 770 мм
  else                tmp1 = 61 + dawlen;
  tmp1 -= 3600; 
  for (i = 215; i < 221; i++)
  { SVLine(i,tmp1,309,FON);
    SVLine(i,61,tmp1,RED);
  }
//******************************************************************************
// вывод давления
  unsigned char tmp2 = (unsigned char)((dawlen/5)-700); // перевод в мм рт.ст.
  put_char(gde,140,3,0xFFE0,FON,7);
  put_char(gde,158,3,0xFFE0,FON,(tmp2/10));
  put_char(gde,176,3,0xFFE0,FON,(tmp2%10));
}
//========================================================================
void showtime(void)
{ unsigned char sym[8]={(chas/10),(chas%10),10,(mins/10),(mins%10),10,(sec/10),(sec%10)};
  unsigned char i = 0, y0 = 50;

  for (i = 0; i < 8; i++)
  { put_char(8,y0,3,0xFFE0,FON,sym[i]);
    y0 += 18; 
  }
  
  if (sec==0)
  { SHLine(0,239,1,FON);
    SHLine(0,239,2,FON);
    SHLine(0,239,3,FON);
  }

  DrawPixel(3,4*sec,YELLOW);  
  DrawPixel(2,4*sec,YELLOW);  
  DrawPixel(1,4*sec,YELLOW);

#ifdef KALIBR
  unsigned char sym2[8]={(VCC/10),(VCC%10),10,(VCCB/10),(VCCB%10),10,(sec/10),(sec%10)};
  y0 = 180;
  for (i = 0; i < 8; i++)
  { put_char(311,y0,1,0xFFE0,FON,sym2[i]);
    y0 += 6; 
  }
#endif KALIBR
}
//==============================================================================
// вывод влажности
void show_hum(unsigned char temper,unsigned char hum)
{
  unsigned char sym2[4] = {temper/10,temper%10,hum/10,hum%10};
  unsigned char i = 0;
  unsigned char y0 = 62;
  for (i = 0; i < 4; i++)
  { put_char(36,y0,2,0xFFE0,FON,sym2[i]);
    y0 += 11;
    if (i==1) y0 += 86;
  }
}
//==============================================================================

