//==============================================================================
// #_18.12.2021
//==============================================================================
#include "main.h"

void TFT9341_reset(void);

void TFT9341_SendCommand(unsigned char cmd);
void TFT9341_SendData(unsigned char dt);

//==============================================================================
void initTFT9341(void)
{
  TFT9341_SendCommand(0x01);//Software Reset

// Следующие 2 команды вносят настройки в регистр управления различными таймингами
  TFT9341_SendData(0x30);

  TFT9341_SendCommand(0xE8);//Driver timing control A
  TFT9341_SendData(0x85);  
  TFT9341_SendData(0x00);  
  TFT9341_SendData(0x78);

  TFT9341_SendCommand(0xEA);//Driver timing control B
  TFT9341_SendData(0x00);  
  TFT9341_SendData(0x00);

  TFT9341_SendCommand(0xED);//Power on Sequence control
  TFT9341_SendData(0x64);  
  TFT9341_SendData(0x03);  
  TFT9341_SendData(0x12);  
  TFT9341_SendData(0x81);


  TFT9341_SendCommand(0xF7);//Pump ratio control
  TFT9341_SendData(0x20);

  TFT9341_SendCommand(0x3A);//Pixel Format Set - 16 bit/pixel
  TFT9341_SendData(0x55);//16bit

  TFT9341_SendCommand(0x36);  // здесь set rotation
  TFT9341_SendData(0x28);     // кнопка снизу

  TFT9341_SendCommand(0x20);//Display inversion OFF

  TFT9341_SendCommand(0xB6);//Display Function Control
  TFT9341_SendData(0x08);  
  TFT9341_SendData(0x82);  
  TFT9341_SendData(0x27);//320 строк

  TFT9341_SendCommand(0xF2);//Enable 3G
  TFT9341_SendData(0x00);//не включаем

  TFT9341_SendCommand(0x11);//Выход из спящего режим
  _delay_ms(150);
  TFT9341_SendCommand(0x29);//Включение дисплея
  _delay_ms(150);
}
//==============================================================================
void initTFT(void)
{ TFT9341_reset();
  _delay_ms(100);
  initTFT9341();
}
//==============================================================================

